/*
	$Id: PluginPermission.java 5818 2011-10-21 11:15:41Z nicklas $

	Copyright (C) 2006 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/

package net.sf.basedb.core.data;

/**
	@author Martin
	@version 2.1
	@see <a href="../../../../../../html/developer/api/data_api.authentication.html">Developer documentation: User authentication</a>
	@see <a href="../../../../../../html/developer/api/data_api.plugins.html">Developer documentation: Plug-ins, jobs and job agents</a>
*/
public class PluginPermission 
{
	public PluginPermission()
	{}
	
	public PluginPermission(int granted, int denied)
	{
		this.granted = granted;
		this.denied = denied;
	}
	
	private int granted;
	
	public void setGranted(int granted)
	{
		this.granted = granted;
	}
	/**
	 	The permissions for the plugin
		@hibernate.property column="`granted`" not-null="true" type="int"
	*/
	public int getGranted()
	{
		return granted;
	}

	private int denied;
	
	public void setDenied(int denied)
	{
		this.denied = denied;
	}
	/**
	  	The plugin's permission can be set to always be used or only if the user has it already.
	  	@hibernate.property column="`denied`" not-null="true" type="int"
	*/
	public int getDenied()
	{
		return denied;
	}	
}
